
%generate (likely) separable data
A = gendats([5 5],2,5)

Y = [ ones(size(A,1),1) +A ]; % extended training vectors
Z = getnlab(A);
Z(Z==2)=-1;

figure(1),scatterd(A)

% fisher mapping
wf=fisherm(A)


%extended weight vector: bias, weightx, weighty
a = [ -0.5 0.1  -0.7 ]';
%
wa = wtomap(wf,a)
plotc({wf,wa})

hold on
scatterd(A(Y*a.*Z<=0,:),'o')
title('Arbitrary linear classifier')
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Perceptron
%a = [ -0.5 0.1  -0.7 ]';
figure(1)
A.name='Batch Perceptron training';
a = 0.001*rand(3,1);
k=0;
eta = 0.2;
imax=120;
errors=1;
J=[];

while k<=imax & sum(errors)>0 
    
  Out=Y*a.*Z;
  errors= Out<=0;
  J = [ J -sum(Out(errors)) ];
    
  grad = sum(-Y(errors,:).*repmat(Z(errors),1,3));
  a = a - eta*grad';
 
  wa = wtomap(wa,a,['k=' num2str(k)]);
  scatterd(A),plotc({wa}),hold on
  scatterd(A(errors,:),'o')
  %disp( [ num2str(a') 
  disp([' Errors: ' num2str(sum(errors))  ' J=' num2str(J(end))  ] );
  k = k + 1;  
  pause(0.1)
end
figure(2),plot(J)
title('Perceptron learning')
xlabel('iterations (k)')
ylabel('criterion (J)')
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%Pseudoinverse method
% Ya = b = Z

b = Z;

a = inv(Y'*Y)*Y'*b;
  Out= Y*a;
  Delta=Out - Z;
  Js=norm(Delta);
  disp(['J = ' num2str(Js) ]) ;


figure(1),scatterd(A)
plotc({wtomap(wf,a,'pinv')})
hold on
scatterd(A(Y*a.*Z<=0,:),'o')
title('Pseudoinverse method')


pause


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%Adaline

A.name='Batch delta rule';
figure(1)
a = 0.001*rand(3,1);
imax=80;
eta=0.01;
k=0;
J=[];
while k<=imax 
    
  Out= Y*a;
  Delta=Out - Z;
  errors= Out.*Z<=0;
  J = [ J norm(Delta)] ;
    
  grad = Y'*Delta;
  a = a - eta*grad;
  
  
  
  wa = wtomap(wa,a,['k=' num2str(k)]);
  scatterd(A),plotc({wa}),hold on
  scatterd(A(errors,:),'o')
  disp( [ num2str(a') ' Errors: ' num2str(sum(errors))  ' J=' num2str(J(end))  ] );
  k = k + 1;  
  pause(0.1)
end

figure(2),plot(J),hold on
plot([0 length(J)],[Js Js],'r'),hold off
legend({'Adaline','Pseudoinv'})
title('LMS learning')
xlabel('iterations (k)')
ylabel('criterion (J)')



