
% Examples of basic (linear) Support Vector Machines
% using STPRTOOLS
% 


%generate (likely) separable data
A = gendats([5 5],2,5)

Y = [ ones(size(A,1),1) +A ]; % extended training vectors
Z = getnlab(A);
Z(Z==2)=-1;

figure(1),scatterd(A)


% %%%%%%%%%%%%%%%%%%%%%%%
data=struct('X',+A','name','kk','y',getnlab(A)','dim',2,'num_data',getsize(A,1));
model = svmquadprog(data)
figure(2),clf,ppatterns(data); psvm(model);


w = sum( model.sv.X'.*repmat(model.Alpha,1,2));
a = [model.b w]';


figure(1), wa = wtomap(fisherm(A),a,['svm']);
  scatterd(A),plotc({wa})
  

pause
  
  
% %%%%%%%%%%%%%%%%%%%%%%%
%generate less (likely) separable data
A = gendats([10 10],2,3)
Y = [ ones(size(A,1),1) +A ]; % extended training vectors
Z = getnlab(A);
Z(Z==2)=-1;


data=struct('X',+A','name','kk','y',getnlab(A)','dim',2,'num_data',getsize(A,1));
model = svmquadprog(data,struct('C',1))
figure(2),clf,ppatterns(data); psvm(model);

w = sum( model.sv.X'.*repmat(model.Alpha,1,2));
a = [model.b w]';


figure(1), wa = wtomap(fisherm(A),a,['svm']);
  scatterd(A),plotc({wa})
  
hold on
scatterd(A(Y*a.*Z<=0,:),'o')
pause